40f0be4fdce5712ec7fa83e01f9679a3c318c08b
[darcs-mirror-metainit.git] / create-sysvinit-file
1 #!/usr/bin/perl -w
2 #
3 # Creates a sysvinit file from a metainit description.
4 #
5
6 use lib './lib';
7 use MetaInit::Parse;
8
9 $filename = shift || die "Filename expected!\n";
10 my $output = shift;
11
12 # Parse the metainit in
13 %initparams = %{MetaInit::Parse::parse($filename)};
14
15 if ($output) {
16         open(STDOUT,'>',$output) or die $!;
17 }
18
19 # Print the "dynamic" part of the initskript
20 print << "EOF"
21 #! /bin/sh
22 #
23 # This a generated file. DO NOT EDIT THIS FILE!
24 # If you want to modify who this file works, please
25 # modify $filename and re-run update-metainit.
26 #
27 # If you are sure that you want to modify this file,
28 # remove this comment, and update-metainit will not override
29 # this script any more.
30 #
31 ### BEGIN INIT INFO
32 # Provides:          $initparams{"Name"}
33 # Default-Start:     2 3 4 5
34 # Default-Stop:      0 1 6
35 # Short-Description: $initparams{"Desc"}
36 EOF
37 ;
38
39 print "# Required-Start:   " . join(" ",@{$initparams{"Required-Start"}}) . "\n";
40 print "# Required-Stop:     " . join(" ",@{$initparams{"Required-Stop"}}) . "\n";
41 print "# Description:       ";
42 print join("\n#                    ",split("\n",$initparams{"Description"})). "\n";
43 print "\n";
44
45 # prevent quoted strings from breaking the generated script:
46
47 my %quoted_initparams;
48
49 while (my ($k, $v) = each %initparams){
50         $quoted_initparams{$k} = quotemeta $v;
51 }
52
53 print << "EOF"
54 ### END INIT INFO
55
56 # WARNING:
57 # This initscript has been autogenerated by metainit.
58 # Do not edit this file, but edit the corresponding metainit
59 # config.
60
61 # PATH should only include /usr/* if it runs after the mountnfs.sh script
62 PATH=/sbin:/usr/sbin:/bin:/usr/bin
63 DESC=$quoted_initparams{"Desc"}
64 NAME=$quoted_initparams{"Name"}
65 DAEMON=$initparams{"Path"}
66 DAEMON_ARGS=$quoted_initparams{"Args"}
67 PIDFILE=/var/run/\$NAME.pid
68 SCRIPTNAME=/etc/init.d/\$NAME
69 EOF
70 ;
71
72 # ... and the rest of the initscript, that is identical for all
73 # metainit-created scripts.
74 print << 'EOF'
75 # Exit if the package is not installed
76 [ -x "$DAEMON" ] || exit 0
77
78 # Read configuration variable file if it is present
79 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
80
81 # Load the VERBOSE setting and other rcS variables
82 . /lib/init/vars.sh
83
84 # Define LSB log_* functions.
85 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
86 . /lib/lsb/init-functions
87
88 #
89 # Function that starts the daemon/service
90 #
91 do_start()
92 {
93 EOF
94 ;
95
96 if($initparams{"Prestart-Hook"}) {
97     print "\t" . join("\n\t",split("\n",$initparams{"Prestart-Hook"}));
98     print "\n";
99 }
100
101 print << 'EOF'
102         # Return
103         #   0 if daemon has been started
104         #   1 if daemon was already running
105         #   2 if daemon could not be started
106         start-stop-daemon --start --background --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
107                 || return 1
108         start-stop-daemon --start --background --quiet --pidfile $PIDFILE --exec $DAEMON -- \
109                 $DAEMON_ARGS \
110                 || return 2
111         # Add code here, if necessary, that waits for the process to be ready
112         # to handle requests from services started subsequently which depend
113         # on this one.  As a last resort, sleep for some time.
114 }
115
116 #
117 # Function that stops the daemon/service
118 #
119 do_stop()
120 {
121         # Return
122         #   0 if daemon has been stopped
123         #   1 if daemon was already stopped
124         #   2 if daemon could not be stopped
125         #   other if a failure occurred
126         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
127         RETVAL="$?"
128         [ "$RETVAL" = 2 ] && return 2
129         # Wait for children to finish too if this is a daemon that forks
130         # and if the daemon is only ever run from this initscript.
131         # If the above conditions are not satisfied then add some other code
132         # that waits for the process to drop all resources that could be
133         # needed by services started subsequently.  A last resort is to
134         # sleep for some time.
135         start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
136         [ "$?" = 2 ] && return 2
137         # Many daemons don't delete their pidfiles when they exit.
138         rm -f $PIDFILE
139 EOF
140 ;
141
142 if($initparams{"Poststop-Hook"}) {
143     print "\t" . join("\n\t",split("\n",$initparams{"Poststop-Hook"}));
144     print "\n";
145 }
146
147 print << 'EOF';
148         return "$RETVAL"
149 }
150
151 #
152 # Function that sends a SIGHUP to the daemon/service
153 #
154 do_reload() {
155         #
156         # If the daemon can reload its configuration without
157         # restarting (for example, when it is sent a SIGHUP),
158         # then implement that here.
159         #
160         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
161         return 0
162 }
163
164 case "$1" in
165   start)
166         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
167         do_start
168         case "$?" in
169                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
170                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
171         esac
172         ;;
173   stop)
174         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
175         do_stop
176         case "$?" in
177                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
178                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
179         esac
180         ;;
181   #reload|force-reload)
182         #
183         # If do_reload() is not implemented then leave this commented out
184         # and leave 'force-reload' as an alias for 'restart'.
185         #
186         #log_daemon_msg "Reloading $DESC" "$NAME"
187         #do_reload
188         #log_end_msg $?
189         #;;
190   restart|force-reload)
191         #
192         # If the "reload" option is implemented then remove the
193         # 'force-reload' alias
194         #
195         log_daemon_msg "Restarting $DESC" "$NAME"
196         do_stop
197         case "$?" in
198           0|1)
199                 do_start
200                 case "$?" in
201                         0) log_end_msg 0 ;;
202                         1) log_end_msg 1 ;; # Old process is still running
203                         *) log_end_msg 1 ;; # Failed to start
204                 esac
205                 ;;
206           *)
207                 # Failed to stop
208                 log_end_msg 1
209                 ;;
210         esac
211         ;;
212   *)
213         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
214         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
215         exit 3
216         ;;
217 esac
218 EOF
219
220 if ($output) {
221         close STDOUT
222 }